Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.orm.hibernate4
Class LocalSessionFactoryBean

    java.lang.Object
      org.springframework.orm.hibernate4.HibernateExceptionTranslator
          org.springframework.orm.hibernate4.LocalSessionFactoryBean

All Implemented Interfaces:
  Aware, DisposableBean, FactoryBean<org.hibernate.SessionFactory>, InitializingBean, ResourceLoaderAware, PersistenceExceptionTranslator

    public class LocalSessionFactoryBean

extends HibernateExceptionTranslator
implements FactoryBean<org.hibernate.SessionFactory>, ResourceLoaderAware, InitializingBean, DisposableBean

`FactoryBean` that creates a Hibernate `SessionFactory`. This is the usual way to set up a shared Hibernate SessionFactory in a Spring application context; the SessionFactory can then be passed to Hibernate-based data access objects via dependency injection.

NOTE: This variant of LocalSessionFactoryBean requires Hibernate 4.0 or higher. It is similar in role to the same-named class in the `orm.hibernate3` package. However, in practice, it is closer to `AnnotationSessionFactoryBean` since its core purpose is to bootstrap a `SessionFactory` from annotation scanning.

Since:
  3.1
Author:
  Juergen Hoeller
See Also:
  `setDataSource(javax.sql.DataSource)`, `setPackagesToScan(java.lang.String...)`

Constructor Summary
`LocalSessionFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`protected org.hibernate.SessionFactory` | `buildSessionFactory(LocalSessionFactoryBuilder sfb)` Subclasses can override this method to perform custom initialization of the SessionFactory instance, creating it via the given Configuration object that got prepared by this LocalSessionFactoryBean.
`void` | `destroy()` Invoked by a BeanFactory on destruction of a singleton.
`org.hibernate.cfg.Configuration` | `getConfiguration()` Return the Hibernate Configuration object used to build the SessionFactory.
`java.util.Properties` | `getHibernateProperties()` Return the Hibernate properties, if any.
`org.hibernate.SessionFactory` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`java.lang.Class<?>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` | `setAnnotatedClasses(java.lang.Class<?>[] annotatedClasses)` Specify annotated entity classes to register with this Hibernate SessionFactory.
`void` | `setAnnotatedPackages(java.lang.String[] annotatedPackages)` Specify the names of annotated packages, for which package-level annotation metadata will be read.
`void` | `setCacheableMappingLocations(Resource[] cacheableMappingLocations)` Set locations of cacheable Hibernate mapping files, for example as web app resource "/WEB-INF/mapping/example.hbm.xml".
`void` | `setConfigLocation(Resource configLocation)` Set the location of a single Hibernate XML config file, for example as classpath resource "classpath:hibernate.cfg.xml".
`void` | `setConfigLocations(Resource[] configLocations)` Set the locations of multiple Hibernate XML config files, for example as classpath resources "classpath:hibernate.cfg.xml,classpath:extension.cfg.xml".
`void` | `setDataSource(javax.sql.DataSource dataSource)` Set the DataSource to be used by the SessionFactory.
`void` | `setEntityInterceptor(org.hibernate.Interceptor entityInterceptor)` Set a Hibernate entity interceptor that allows to inspect and change property values before writing to and reading from the database.
`void` | `setHibernateProperties(java.util.Properties hibernateProperties)` Set Hibernate properties, such as "hibernate.dialect".
`void` | `setMappingDirectoryLocations(Resource[] mappingDirectoryLocations)` Set locations of directories that contain Hibernate mapping resources, like "WEB-INF/mappings".
`void` | `setMappingJarLocations(Resource[] mappingJarLocations)` Set locations of jar files that contain Hibernate mapping resources, like "WEB-INF/lib/example.hbm.jar".
`void` | `setMappingLocations(Resource[] mappingLocations)` Set locations of Hibernate mapping files, for example as classpath resource "classpath:example.hbm.xml".
`void` | `setMappingResources(java.lang.String[] mappingResources)` Set Hibernate mapping resources to be found in the class path, like "example.hbm.xml" or "mypackage/example.hbm.xml".
`void` | `setNamingStrategy(org.hibernate.cfg.NamingStrategy namingStrategy)` Set a Hibernate NamingStrategy for the SessionFactory, determining the physical column and table names given the info in the mapping document.
`void` | `setPackagesToScan(java.lang.String... packagesToScan)` Specify packages to search for autodetection of your entity classes in the classpath.
`void` | `setResourceLoader(ResourceLoader resourceLoader)` Set the ResourceLoader that this object runs in.

Methods inherited from class org.springframework.orm.hibernate4.HibernateExceptionTranslator
`convertHibernateAccessException, translateExceptionIfPossible`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### LocalSessionFactoryBean

    public LocalSessionFactoryBean()

Method Detail

### setDataSource

    public void setDataSource(javax.sql.DataSource dataSource)

  Set the DataSource to be used by the SessionFactory. If set, this will override corresponding settings in Hibernate properties.

  If this is set, the Hibernate settings should not define a connection provider to avoid meaningless double configuration.

### setConfigLocation

    public void setConfigLocation(Resource configLocation)

  Set the location of a single Hibernate XML config file, for example as classpath resource "classpath:hibernate.cfg.xml".

  Note: Can be omitted when all necessary properties and mapping resources are specified locally via this bean.

  See Also:
    `Configuration.configure(java.net.URL)`

### setConfigLocations

    public void setConfigLocations(Resource[] configLocations)

  Set the locations of multiple Hibernate XML config files, for example as classpath resources "classpath:hibernate.cfg.xml,classpath:extension.cfg.xml".

  Note: Can be omitted when all necessary properties and mapping resources are specified locally via this bean.

  See Also:
    `Configuration.configure(java.net.URL)`

### setMappingResources

    public void setMappingResources(java.lang.String[] mappingResources)

  Set Hibernate mapping resources to be found in the class path, like "example.hbm.xml" or "mypackage/example.hbm.xml". Analogous to mapping entries in a Hibernate XML config file. Alternative to the more generic setMappingLocations method.

  Can be used to add to mappings from a Hibernate XML config file, or to specify all mappings locally.

  See Also:
    `setMappingLocations(org.springframework.core.io.Resource[])`, `Configuration.addResource(java.lang.String, java.lang.ClassLoader)`

### setMappingLocations

    public void setMappingLocations(Resource[] mappingLocations)

  Set locations of Hibernate mapping files, for example as classpath resource "classpath:example.hbm.xml". Supports any resource location via Spring's resource abstraction, for example relative paths like "WEB-INF/mappings/example.hbm.xml" when running in an application context.

  Can be used to add to mappings from a Hibernate XML config file, or to specify all mappings locally.

  See Also:
    `Configuration.addInputStream(java.io.InputStream)`

### setCacheableMappingLocations

    public void setCacheableMappingLocations(Resource[] cacheableMappingLocations)

  Set locations of cacheable Hibernate mapping files, for example as web app resource "/WEB-INF/mapping/example.hbm.xml". Supports any resource location via Spring's resource abstraction, as long as the resource can be resolved in the file system.

  Can be used to add to mappings from a Hibernate XML config file, or to specify all mappings locally.

  See Also:
    `Configuration.addCacheableFile(java.io.File)`

### setMappingJarLocations

    public void setMappingJarLocations(Resource[] mappingJarLocations)

  Set locations of jar files that contain Hibernate mapping resources, like "WEB-INF/lib/example.hbm.jar".

  Can be used to add to mappings from a Hibernate XML config file, or to specify all mappings locally.

  See Also:
    `Configuration.addJar(java.io.File)`

### setMappingDirectoryLocations

    public void setMappingDirectoryLocations(Resource[] mappingDirectoryLocations)

  Set locations of directories that contain Hibernate mapping resources, like "WEB-INF/mappings".

  Can be used to add to mappings from a Hibernate XML config file, or to specify all mappings locally.

  See Also:
    `Configuration.addDirectory(java.io.File)`

### setEntityInterceptor

    public void setEntityInterceptor(org.hibernate.Interceptor entityInterceptor)

  Set a Hibernate entity interceptor that allows to inspect and change property values before writing to and reading from the database. Will get applied to any new Session created by this factory.

  See Also:
    `Configuration.setInterceptor(org.hibernate.Interceptor)`

### setNamingStrategy

    public void setNamingStrategy(org.hibernate.cfg.NamingStrategy namingStrategy)

  Set a Hibernate NamingStrategy for the SessionFactory, determining the physical column and table names given the info in the mapping document.

  See Also:
    `Configuration.setNamingStrategy(org.hibernate.cfg.NamingStrategy)`

### setHibernateProperties

    public void setHibernateProperties(java.util.Properties hibernateProperties)

  Set Hibernate properties, such as "hibernate.dialect".

  Note: Do not specify a transaction provider here when using Spring-driven transactions. It is also advisable to omit connection provider settings and use a Spring-set DataSource instead.

  See Also:
    `setDataSource(javax.sql.DataSource)`

### getHibernateProperties

    public java.util.Properties getHibernateProperties()

  Return the Hibernate properties, if any. Mainly available for configuration through property paths that specify individual keys.

### setAnnotatedClasses

    public void setAnnotatedClasses(java.lang.Class<?>[] annotatedClasses)

  Specify annotated entity classes to register with this Hibernate SessionFactory.

  See Also:
    `org.hibernate.cfg.Configuration#addAnnotatedClass(Class)`

### setAnnotatedPackages

    public void setAnnotatedPackages(java.lang.String[] annotatedPackages)

  Specify the names of annotated packages, for which package-level annotation metadata will be read.

  See Also:
    `org.hibernate.cfg.Configuration#addPackage(String)`

### setPackagesToScan

    public void setPackagesToScan(java.lang.String... packagesToScan)

  Specify packages to search for autodetection of your entity classes in the classpath. This is analogous to Spring's component-scan feature (`ClassPathBeanDefinitionScanner`).

### setResourceLoader

    public void setResourceLoader(ResourceLoader resourceLoader)

  Description copied from interface: `ResourceLoaderAware`
  Set the ResourceLoader that this object runs in.

  This might be a ResourcePatternResolver, which can be checked through `instanceof ResourcePatternResolver`. See also the `ResourcePatternUtils.getResourcePatternResolver` method.

  Invoked after population of normal bean properties but before an init callback like InitializingBean's `afterPropertiesSet` or a custom init-method. Invoked before ApplicationContextAware's `setApplicationContext`.

  Specified by:
    `setResourceLoader` in interface `ResourceLoaderAware`
  Parameters:
    `resourceLoader` - ResourceLoader object to be used by this object
  See Also:
    `ResourcePatternResolver`, `ResourcePatternUtils.getResourcePatternResolver(org.springframework.core.io.ResourceLoader)`

### afterPropertiesSet

    public void afterPropertiesSet()
                            throws java.io.IOException

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Throws:
    `java.io.IOException`

### buildSessionFactory

    protected org.hibernate.SessionFactory buildSessionFactory(LocalSessionFactoryBuilder sfb)

  Subclasses can override this method to perform custom initialization of the SessionFactory instance, creating it via the given Configuration object that got prepared by this LocalSessionFactoryBean.

  The default implementation invokes LocalSessionFactoryBuilder's buildSessionFactory. A custom implementation could prepare the instance in a specific way (e.g. applying a custom ServiceRegistry) or use a custom SessionFactoryImpl subclass.

  Parameters:
    `sfb` - LocalSessionFactoryBuilder prepared by this LocalSessionFactoryBean
  Returns:
    the SessionFactory instance
  See Also:
    `LocalSessionFactoryBuilder.buildSessionFactory()`

### getConfiguration

    public final org.hibernate.cfg.Configuration getConfiguration()

  Return the Hibernate Configuration object used to build the SessionFactory. Allows for access to configuration metadata stored there (rarely needed).

  Throws:
    `java.lang.IllegalStateException` - if the Configuration object has not been initialized yet

### getObject

    public org.hibernate.SessionFactory getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean<org.hibernate.SessionFactory>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public java.lang.Class<?> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<org.hibernate.SessionFactory>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<org.hibernate.SessionFactory>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### destroy

    public void destroy()

  Description copied from interface: `DisposableBean`
  Invoked by a BeanFactory on destruction of a singleton.

  Specified by:
    `destroy` in interface `DisposableBean`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD